#include <iostream>
#include <execinfo.h>

#define BOOST_STACKTRACE_USE_BACKTRACE
#include <boost/stacktrace.hpp>
 
using namespace  std;

void bt_backtrace()
{
    cout << "\n######## Printing stacktrace using GUN/LINUX backtrace library  ########" << endl;
    const int BUF_SIZE = 50;
    void * buffer[BUF_SIZE];
    int nbt = backtrace(buffer, BUF_SIZE);
    backtrace_symbols_fd(buffer, nbt, fileno(stdout));
    cout << endl;
}

void bt_final_boost2()
{
    cout << "\n########   Printing stacktrace using Boost.Stacktrace library   ########" << endl;
    auto st = boost::stacktrace::stacktrace();
    int nframe = 0;
    for (auto it = st.begin(); it != st.end(); ++it) {
        cout << " " << nframe++ << "# ";
        cout << it->name() << " at "  << it->source_file() << ":" << it->source_line() << endl;
#if 0
        boost::stacktrace::detail::location_from_symbol loc(it->address());
        auto source_line = it->source_line();
 
        if (source_line == 0) {
            // When BOOST_STACKTRACE_USE_BACKTRACE is NOT defined and exe is NOT linked with libbacktrace library
            cout << "# " << it->address() << " in " << loc.name() <<endl;
        } else {
            // When BOOST_STACKTRACE_USE_BACKTRACE is defined and exe is linked with libbacktrace library
            cout << "# " << it->name() << " at " << it->source_file() << ":" << it->source_line() <<endl;
        }
#endif
    }
}

void bt_final_boost1()
{
    cout << "\n########   Printing stacktrace using Boost.Stacktrace library   ########" << endl;
    cout << boost::stacktrace::stacktrace();
}

int cloc;
void bt_final()
{
    cloc = clock();
    bt_backtrace();
    cout << "bt_backtrace Time Taken (sec): " << (clock() - cloc)*1.0/CLOCKS_PER_SEC << endl;

    cloc = clock();
    bt_final_boost1();
    cout << "bt_final_boost1 Time Taken (sec): " << (clock() - cloc)*1.0/CLOCKS_PER_SEC << endl;

    cloc = clock();
    bt_final_boost2();
    cout << "bt_final_boost2 Time Taken (sec): " << (clock() - cloc)*1.0/CLOCKS_PER_SEC << endl;
}

void bt5() { bt_final(); }
void bt4() { bt5(); }
void bt3() { bt4(); }
void bt2() { bt3(); }
void bt1() { bt2(); }
void bt()  { bt1(); }
 
int main()
{
    bt();
    return 0;
}
